﻿' ------------------------------------------------------------------------------------------
' 
' ftTeachDaten.VB                                                    Ulrich Müller  14.06.06
'                                                                    PCS1700 VB 2005 Express
' ftTeach : Klassen für persistente Daten
'           XML Serialisierung, Einzeldaten, Tabelle
' Die Tabelle RobModelle enthält eine Liste von 10 Robotdatensätzen, auf Position 0 den
' zuletzt verwendeten RobSatz. 
' Die Tabelle IntModelle enthält eine Liste von 10 Interfacedatensätzen, auf Position 0
' ebenfalls den zuletzt verwendeten
' Die Datensätze können über entsprechende Forms den Bedürfnissen des Einsatzes angepaßt
' werden. Wenn das zugehörenden ftTeachDaten.XML nicht vorhanden ist, wird es hier neu
' erstellt. Die Instanz der Klasse ftTeachDaten wird über Serialisierung persistent 
' gehalten (in ftTeachMain).
'
' ------------------------------------------------------------------------------------------

Imports FishFace40

Public Structure RobSatz
  Public Name As String           ' --- Rob1 - Rob9 
  Public Typ As Integer           ' --- 0 : Greifer, 1 : Magnet
  Public Text As String           ' --- beschreibender Text
  Public SauleMax As Integer      ' --- max. Fahrweg in Impulsen ab Endtaster
  Public ArmHMax As Integer
  Public ArmVMax As Integer
  Public GreiferMax As Integer
End Structure

Public Structure IntSatz
  Public Typ As IFTypen            ' --- Interfacetyp
  Public PortNr As Integer         ' --- 0 : USB, 1 - 4 COM
  Public SerialNr As Integer       ' --- SerienNummer des ROBO Interfaces
  Public FirmwareVersion As String '--- FirmwareVersion des ROBO Interfaces
End Structure

Public Class ftTeachDaten
  Public FormLeft As Integer = 0
  Public FormTop As Integer = 0
  Public RobModelle(9) As RobSatz
  Public IntModelle(9) As IntSatz

  Public Sub New()
    ' --- Erstellen der Default-Werte von ftTeachDaten, wenn kein ftTeachDaten.XML vorh.
    Dim i%
    Dim rm As RobSatz
    Dim ri As IntSatz

    ' --- Liste der Robotermodelle ----

    rm.Name = "Rob1"
    rm.Typ = 0
    rm.Text = "Standard Säulen-Roboter"
    rm.SauleMax = 225
    rm.ArmHMax = 160
    rm.ArmVMax = 150
    rm.GreiferMax = 26
    RobModelle(0) = rm
    For i = 1 To RobModelle.Length - 1
      rm.Name = "Rob" & i
      RobModelle(i) = rm
    Next

    ' --- Liste der Interfacetypen ----

    ri.Typ = IFTypen.ftROBO_first_USB
    ri.PortNr = 0
    ri.SerialNr = 0
    ri.FirmwareVersion = "v0.0.0.0"
    IntModelle(0) = ri
    IntModelle(1) = ri
    ri.Typ = IFTypen.ftIntelligent_IF
    ri.PortNr = 1
    IntModelle(2) = ri
    ri.Typ = IFTypen.ftIntelligent_IF_Slave
    ri.PortNr = 1
    IntModelle(3) = ri
    ri.Typ = IFTypen.ftROBO_IF_IIM
    ri.PortNr = 1
    IntModelle(4) = ri
    ri.Typ = IFTypen.ftROBO_IF_USB
    ri.PortNr = 0
    IntModelle(5) = ri
    ri.Typ = IFTypen.ftROBO_IF_COM
    ri.PortNr = 1
    IntModelle(6) = ri
    ri.Typ = IFTypen.rfROBO_IF_Over_RF
    ri.PortNr = 0
    IntModelle(7) = ri
    ri.Typ = IFTypen.ftROBO_IO_Extension
    ri.PortNr = 0
    IntModelle(8) = ri
    ri.Typ = IFTypen.ftROBO_RF_Datalink
    ri.PortNr = 0
    IntModelle(9) = ri
  End Sub
End Class
