' -----------------------------------------------------------------------------------------
' 
' ftTeachMain.VB                                                    Ulrich Mller  14.06.06
'                                                                   PCS1700 VB 2005 Express
' ftTeachVB2005 : TeachIn-Programm fr Robots vom Typ Industry Robot (SulenRoboter ...)
'                 Basis FishFace2005.DLL
' Bei FormLoad werden die Interface und Modelldaten aus ftTeachDaten.XML bernommen und bei 
'     FormClosed die ggf. modifizierten (ftTeachModell, ftTeachSchnitt) wieder gespeichert.
' ber das Daten Menu knnen Scriptfiles fr den AutomatikBetrieb des Robots geladen
'     bzw. gespeichert werden.
' Die Gesamtkontrolle des Programms erfolgt ber die Routine cmdAction_Click und die 
'    Sub ModusWechsel zur Steuerung der Controlzustnde
' Das TeachIn erfolgt ber MausKlicks auf die Robotgraphik (lblRobMouseDown, -Up)
' Die jeweils erreichte RobotPosition kann ber die ButtonRoutinen von pnlScript
'     in das ScriptFile bernommen werden
' Die im ScriptFile gelisteten RobotPositionen knnen ber die ButtonRoutinen von
'     pnlRun einzeln oder auch gesamt angefahren werden.
'
' ------------------------------------------------------------------------------------------

Imports System.Xml.Serialization
Imports FishFace40

Public Class ftTeachMain

  Private Enum PrgModus
    None
    Ein
    Home
    TeachIn
    Run
  End Enum

  ' --- Globale Variable --------------------------

  Private pd As ftTeachDaten
  Private WithEvents ft As FishRobot
  Private Modell As New RobSatz()
  Private Anschluss As New IntSatz()
  Private IniName As String = New IO.DirectoryInfo(".\").FullName & "ftTeachDaten.XML"
  Private ProgStatus As PrgModus = PrgModus.None
  Private ScriptName As String
  Private IsDirty As Boolean = False
  Private MoveWerte(4) As Integer

  ' --- Hilfsprogramme -----------------------------

  Private Sub ModellDaten()
    ' --- Anzeige der Robot und Interface Daten in lstDaten ---
    lblTitel.Text = Modell.Text
    lstDaten.Items.Clear()
    lstDaten.Items.Add("Modell : " & Modell.Name)
    lstDaten.Items.Add("mit : " & IIf(Modell.Typ = 0, "Greifer", "Magnet"))
    lstDaten.Items.Add("")
    lstDaten.Items.Add("Arbeitsraum")
    lstDaten.Items.Add("Sule : " & Modell.SauleMax)
    lstDaten.Items.Add("ArmH  : " & Modell.ArmHMax)
    lstDaten.Items.Add("ArmV  : " & Modell.ArmVMax)
    If Modell.Typ = 0 Then lstDaten.Items.Add("Greifer : " & Modell.GreiferMax)
    lstDaten.Items.Add(" ")
    lstDaten.Items.Add("Interface")
    lstDaten.Items.Add(Anschluss.Typ.ToString)
    lstDaten.Items.Add(IIf(Anschluss.PortNr = 0, "USB", "COM" & Anschluss.PortNr))
    If Anschluss.PortNr = 0 Then
      lstDaten.Items.Add("SerialNr : " & Anschluss.SerialNr)
      lstDaten.Items.Add("Firmware Version")
      lstDaten.Items.Add(Anschluss.FirmwareVersion)
    End If
  End Sub

  Private Sub ModusWechsel(ByVal newModus As PrgModus)
    ' --- Modifikation der beim Wechsel des Betriebsmodus beteiligten Controls ---
    Select Case newModus
      Case PrgModus.Ein
        lblStatus.Text = "EINschalten"
        lblStatus.BackColor = Color.Gainsboro
        cmdAction.Text = "EIN"
        cmdAction.Enabled = True
        cmdEnde.Text = "Abbrechen"
        cmdEnde.Enabled = True
        mnuDatei.Enabled = True
        mnuExtras.Enabled = True
        pnlScript.Enabled = False
        pnlScript.BackColor = Color.Gray
        pnlRun.Enabled = False
        pnlRun.BackColor = Color.Gray
        picDrive.Enabled = False
        picDrive.BackColor = Color.Gray
      Case PrgModus.Home
        lblStatus.Text = "Home anfahren"
        lblStatus.BackColor = Color.Green
        cmdAction.Text = "HOME"
        cmdAction.Enabled = True
        cmdEnde.Text = "ENDE"
        cmdEnde.Enabled = False
        mnuDatei.Enabled = True
        mnuExtras.Enabled = False
        pnlScript.Enabled = False
        pnlScript.BackColor = Color.Gray
        pnlRun.Enabled = False
        pnlRun.BackColor = Color.Gray
        picDrive.Enabled = False
        picDrive.BackColor = Color.Gray
      Case PrgModus.TeachIn
        lblStatus.Text = "TeachIn"
        lblStatus.BackColor = Color.Green
        cmdAction.Text = "HOME"
        cmdAction.Enabled = True
        cmdEnde.Text = "ENDE"
        cmdEnde.Enabled = True
        mnuDatei.Enabled = True
        mnuExtras.Enabled = False
        pnlScript.Enabled = True
        pnlScript.BackColor = Color.Gainsboro
        pnlRun.Enabled = True
        pnlRun.BackColor = Color.Gainsboro
        picDrive.Enabled = True
        picDrive.BackColor = Color.Gainsboro
      Case PrgModus.Run
        lblStatus.Text = "RUN"
        lblStatus.BackColor = Color.GreenYellow
        cmdAction.Text = "HALT"
        cmdAction.Enabled = True
        cmdEnde.Text = "ENDE"
        cmdEnde.Enabled = False
        mnuDatei.Enabled = False
        mnuExtras.Enabled = False
        pnlScript.Enabled = False
        pnlScript.BackColor = Color.Gray
        pnlRun.Enabled = True
        pnlRun.BackColor = Color.Gainsboro
        picDrive.Enabled = True
        picDrive.BackColor = Color.Gainsboro
    End Select
    ProgStatus = newModus
  End Sub

  Private Sub HomeRun()
    ' --- Anfahren der Home Position (alle Endtaster ein) ------------
    Dim i%
    ft.NotHalt = False
    ft.MoveHome()
    ft.ClearMotors()
    lblSaulePos.Text = "0"
    lblArmHPos.Text = "0"
    lblArmVPos.Text = "0"
    For i = 0 To MoveWerte.Length - 1
      MoveWerte(i) = 0
    Next
  End Sub

  Private Function MoveToScript() As String
    ' --- bertragen der aktuellen Position in eine Textzeile ---
    Return ft.MotCntl(0).actPos.ToString("   000") & _
           ft.MotCntl(1).actPos.ToString("   000") & _
           ft.MotCntl(2).actPos.ToString("   000") & _
           ft.MotCntl(3).actPos.ToString("   000")
  End Function

  Private Sub ScriptToMove()
    ' --- bertragen der aktuellen Textzeilen von lstScript in die aktuelle Position ---
    Dim Z As String = lstScript.Text
    MoveWerte(0) = Convert.ToInt32(Z.Substring(0, 6))
    MoveWerte(1) = Convert.ToInt32(Z.Substring(6, 6))
    MoveWerte(2) = Convert.ToInt32(Z.Substring(12, 6))
    MoveWerte(3) = Convert.ToInt32(Z.Substring(18, 6))
  End Sub

  Private Sub DirtySpeichern()
    ' --- Bedingtes Speichern des ScriptFiles bei IsDirty = True -----------------
    If IsDirty Then
      If MessageBox.Show("Soll das Script gespeichert werden ?", _
                          Application.ProductName, MessageBoxButtons.YesNo, _
                          MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) _
                          = Windows.Forms.DialogResult.Yes Then
        If ScriptName = " [Neu]" Then
          saveScript.InitialDirectory = Application.StartupPath
          If saveScript.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Speichern(saveScript.FileName)
          End If
        Else
          Speichern(ScriptName)
        End If
      End If
    End If
  End Sub

  Private Sub Speichern(ByVal FileName As String)
    ' --- Formatiertes Speichern des ScriptFiles in ein einfaches Textfile ---
    Dim sr As New IO.StreamWriter(FileName)
    Dim i%
    For i = 0 To lstScript.Items.Count - 1
      lstScript.SelectedIndex = i
      sr.WriteLine(lstScript.SelectedItem)
    Next
    sr.Close()
    Me.Text = Application.ProductName & " - " & _
              FileName.Substring(FileName.LastIndexOf("\") + 1)
    IsDirty = False
  End Sub

  Private Sub Zusatz(ByVal OnOff As Integer)
    ' --- Bettigen des Werkzeugs : Greifer oder Magnet, Lampe ... ---
    MoveWerte(3) = OnOff
    Try
      If Modell.Typ = 0 Then
        If OnOff = 0 Then
          ft.MoveTo(ft.MotCntl(0).actPos, ft.MotCntl(1).actPos, ft.MotCntl(2).actPos, 0)
        Else
          ft.MoveTo(ft.MotCntl(0).actPos, ft.MotCntl(1).actPos, ft.MotCntl(2).actPos, _
                    ft.MotCntl(3).maxPos)
        End If
      Else
        ft.SetMotor(Out.M4, OnOff)
        ft.Pause(500)
      End If
    Catch eft As FishFaceException
      lblBetrieb.BackColor = Color.Red
      lblStatus.Text = eft.Message
    End Try
  End Sub

  ' ------- Button Routinen --------------------------------------------------------

  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAction.Click
    ' --- Zentrale Steuerungsroutine --------------------------------
    Select Case cmdAction.Text
      Case "EIN"
        Try
          Dim MotList(,) As Integer = {{1, Modell.SauleMax}, {2, Modell.ArmHMax}, _
                                       {3, Modell.ArmVMax}, {4, Modell.GreiferMax}}
          ft = New FishRobot(MotList)
          If Anschluss.PortNr > 0 Then      ' --- Anschluss an COM
            ft.OpenInterface(Anschluss.Typ, Anschluss.PortNr, 999, True)
          Else                              ' --- Anschluss an USB
            ft.OpenInterface(Anschluss.Typ, Anschluss.SerialNr, True)
          End If
          Anschluss.FirmwareVersion = ft.ActDevice.Firmware
          Anschluss.SerialNr = ft.ActDevice.SerialNr
          tmrI.Enabled = True
          ModellDaten()
          ModusWechsel(PrgModus.Home)
        Catch eft As FishFaceException
          lblStatus.Text = eft.Message
          lblStatus.BackColor = Color.Red
          ft.CloseInterface()
        End Try
      Case "HOME"
        Try
          ModusWechsel(PrgModus.Run)
          HomeRun()
          ModusWechsel(PrgModus.TeachIn)
        Catch eft As FishFaceException
          lblStatus.Text = eft.Message
          lblStatus.BackColor = Color.Red
        End Try
      Case "HALT"
        ft.NotHalt = True
        chkRunRepeat.Checked = False
    End Select
  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    ' --- Beenden des Programms ----------------------
    Me.Close()
  End Sub

  ' ----- Form Routinen ---------------------------------------------------------------

  Private Sub ftTeachMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' --- Initialisierung, primr aus dem serialisiertem ftTeachDaten.XML -------------
    ProgStatus = PrgModus.None
    If IO.File.Exists(IniName) Then
      Dim ser As New XmlSerializer(GetType(ftTeachDaten))
      Dim xml As New IO.StreamReader(IniName, IO.FileMode.Open)
      pd = CType(ser.Deserialize(xml), ftTeachDaten)
      xml.Close()
    Else
      pd = New ftTeachDaten()
    End If
    Me.Left = pd.FormLeft
    Me.Top = pd.FormTop
    Me.Text = Application.ProductName
    ScriptName = " [Neu]"
    Modell = pd.RobModelle(0)
    Anschluss = pd.IntModelle(0)
    ModellDaten()
    ModusWechsel(PrgModus.Ein)
  End Sub

  Private Sub ftTeachMain_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    ' --- Programmabbruch ber (x) unterbinden ---
    If cmdAction.Text = "HALT" Then e.Cancel = True
  End Sub

  Private Sub ftTeachMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
    ' --- Update von ftTeachDaten.XML durch Serialisieren ---
    tmrI.Enabled = False
    Dim ser As New XmlSerializer(GetType(ftTeachDaten))
    Dim xml As New IO.StreamWriter(IniName)
    pd.FormLeft = Me.Left
    pd.FormTop = Me.Top
    ser.Serialize(xml, pd)
    xml.Close()
    DirtySpeichern()
    If Not IsNothing(ft) Then ft.CloseInterface()
  End Sub

  ' --------- Menu Routinen ------------------------------------------

  Private Sub mnuModell_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuModell.Click
    ' --- Aufruf Dialogform mit Modelldaten -------
    Dim m As New ftTeachModell(pd)
    m.Left = Me.Left + Me.Width - m.Width - 20
    m.Top = Me.Top + Me.Height - m.Height - 20
    m.ShowDialog()
    Modell = pd.RobModelle(0)
    ModellDaten()
  End Sub

  Private Sub mnuAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAbout.Click
    ' --- Aufruf der Dialogform About --------
    Dim a As New ftTeachAbout
    a.Left = Me.Left + Me.Width - a.Width - 20
    a.Top = Me.Top + Me.Height - a.Height - 20
    a.ShowDialog()
  End Sub

  Private Sub mnuInterface_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuInterface.Click
    ' --- Aufruf der Dialogform mit InterfaceDaten ---
    Dim s As New ftTeachSchnitt(pd)
    s.Left = Me.Left + Me.Width - s.Width - 20
    s.Top = Me.Top + Me.Height - s.Height - 20
    s.ShowDialog()
    Anschluss = pd.IntModelle(0)
    ModellDaten()
  End Sub

  Private Sub mnuNeu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuNeu.Click
    ' --- Anlegen eines neuen ScriptFiles -----
    Dim i%
    lstScript.Items.Clear()
    ScriptName = " [Neu]"
    Me.Text = Application.ProductName & ScriptName
    For i = 0 To MoveWerte.Length - 1
      MoveWerte(i) = 0
    Next
    lstScript.Items.Add("     0     0     0     0")
    lstScript.SelectedIndex = 0
    IsDirty = False
  End Sub

  Private Sub mnuOffnen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOffnen.Click
    ' --- Einlesen eines ScriptFiles nach lstScript ---
    Dim Z As String
    DirtySpeichern()
    openScript.InitialDirectory = Application.StartupPath
    If openScript.ShowDialog() = Windows.Forms.DialogResult.OK Then
      ScriptName = openScript.FileName
      Dim sr As New IO.StreamReader(ScriptName)
      Z = sr.ReadLine()
      lstScript.Items.Clear()
      Do Until IsNothing(Z)
        lstScript.Items.Add(Z)
        Z = sr.ReadLine()
      Loop
      sr.Close()
      lstScript.SelectedIndex = 0
      Me.Text = Application.ProductName & " - " & _
                ScriptName.Substring(ScriptName.LastIndexOf("\") + 1)
      IsDirty = False
    End If
  End Sub

  Private Sub mnuSpeichern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSpeichern.Click
    ' --- Speichern des aktuellen ScriptFiles von lstScript in ein TextFile ---
    If ScriptName = " [Neu]" Then
      saveScript.InitialDirectory = Application.StartupPath
      If saveScript.ShowDialog() = Windows.Forms.DialogResult.OK Then
        Speichern(saveScript.FileName)
      End If
    Else
      Speichern(ScriptName)
    End If
  End Sub

  Private Sub mnuSpeichernU_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSpeichernU.Click
    ' --- Speichern des akt. ScriptFiles von lstScript in ein TextFile mit neuem Namen ---
    saveScript.InitialDirectory = Application.StartupPath
    If saveScript.ShowDialog() = Windows.Forms.DialogResult.OK Then
      Speichern(saveScript.FileName)
    End If
  End Sub

  Private Sub mnuBeenden_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBeenden.Click
    ' --- Beenden des Programms ---
    Me.Close()
  End Sub

  ' --- picDrive Routinen ------------------------------------

  Private Sub lblRobMouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lblSauleRechts.MouseDown, lblSauleLinks.MouseDown, lblArmVAb.MouseDown, lblArmHVor.MouseDown, lblArmHRuck.MouseDown, lblArmHoch.MouseDown
    ' --- Zentrale TeachIn SteuerungsRoutine : Start einer Achse ---
    If IsNothing(ft) Then Return
    Dim L As Label = sender
    ft.NotHalt = False
    Try
      Select Case L.Tag
        Case 1                 ' --- Sule zum Endtaster
          ft.MoveTo(0, ft.MotCntl(1).actPos, ft.MotCntl(2).actPos)
        Case 2                 ' --- Sule weg vom Endtaster
          ft.MoveTo(ft.MotCntl(0).maxPos, ft.MotCntl(1).actPos, ft.MotCntl(2).actPos)
        Case 3                 ' --- Arm, horizontal, zurck
          ft.MoveTo(ft.MotCntl(0).actPos, 0, ft.MotCntl(2).actPos)
        Case 4                  ' --- Arm, horizontal, vor
          ft.MoveTo(ft.MotCntl(0).actPos, ft.MotCntl(1).maxPos, ft.MotCntl(2).actPos)
        Case 5                  ' --- Arm, vertikal, auf
          ft.MoveTo(ft.MotCntl(0).actPos, ft.MotCntl(1).actPos, 0)
        Case 6                  ' --- Arm, vertikal, ab 
          ft.MoveTo(ft.MotCntl(0).actPos, ft.MotCntl(1).actPos, ft.MotCntl(2).maxPos)
      End Select
    Catch eft As FishFaceException
      lblBetrieb.BackColor = Color.Red
      lblStatus.Text = eft.Message
    End Try
  End Sub

  Private Sub lblRobMouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lblSauleRechts.MouseUp, lblSauleLinks.MouseUp, lblArmVAb.MouseUp, lblArmHVor.MouseUp, lblArmHRuck.MouseUp, lblArmHoch.MouseUp
    ' --- Beenden einer TeachIn Aktion ---------
    If Not IsNothing(ft) Then ft.NotHalt = True
  End Sub

  Private Sub lblGreiferClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblGreiferZu.Click, lblGreiferAuf.Click
    ' --- TeachIn Steuerung fr das Werkzeug ---
    If IsNothing(ft) Then Return
    ModusWechsel(PrgModus.Run)
    ft.NotHalt = False
    Dim L As Label = sender
    Dim OnOff As Integer = L.Tag
    If OnOff = 7 Then OnOff = 1 Else OnOff = 0
    Zusatz(OnOff)
    ModusWechsel(PrgModus.TeachIn)
  End Sub

  ' -------- Timer Routinen --------------------------------------------

  Private Sub tmrI_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrI.Tick
    ' --- berwachung des Interface Zustandes ---
    Try
      Dim res As Integer = ft.Outputs
      lblBetrieb.BackColor = Color.Green
    Catch eft As FishFaceException
      lblBetrieb.BackColor = Color.Red
      lblStatus.Text = eft.Message
    End Try
  End Sub

  ' --- Positionsanzeigen ----------------------

  Private Sub ft_PositionChange(ByVal sender As Object, ByVal ActPositions() As Integer) Handles ft.PositionChange
    ' --- Laufende Anzeige der aktuellen Robot-Position ---
    Try
      Dim EW As Integer = ft.Outputs
      lblSaulePos.Text = ActPositions(0)
      If (EW And &H3) > 0 Then
        lblSaule.BackColor = Color.Green
      Else
        lblSaule.BackColor = Color.Gray
      End If
      lblArmHPos.Text = ActPositions(1)
      If (EW And &HC) > 0 Then
        lblArmH.BackColor = Color.GreenYellow
      Else
        lblArmH.BackColor = Color.Gray
      End If
      lblArmVPos.Text = ActPositions(2)
      If (EW And &H30) > 0 Then
        lblArmV.BackColor = Color.GreenYellow
      Else
        lblArmV.BackColor = Color.Gray
      End If
    Catch eft As FishFaceException
      lblBetrieb.BackColor = Color.Red
      lblStatus.Text = eft.Message
    End Try
  End Sub

  ' --- pnlScript Routinen ------------------------------------------

  Private Sub cmdPosSpeichern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPosSpeichern.Click
    ' --- Speichern der aktuellen RobotPosition in die markierte Zeile des ScriptFiles ---
    If lstScript.Items.Count < 1 Then Return
    Dim i As Integer = lstScript.SelectedIndex
    lstScript.Items.RemoveAt(i)
    lstScript.Items.Insert(i, MoveToScript())
    IsDirty = True
  End Sub

  Private Sub cmdPosEinfugen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPosEinfugen.Click
    ' --- Einfgen der akt. RobotPosition vor die markierte Position ---
    If lstScript.SelectedIndex < 0 Then Return
    Dim i As Integer = lstScript.SelectedIndex
    lstScript.Items.Insert(i, MoveToScript())
    lstScript.SelectedIndex = i
    IsDirty = True
  End Sub

  Private Sub cmdPosAnfugen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPosAnfugen.Click
    ' --- Anfgen der akt. RobotPosition an das ScriptFile ---
    lstScript.Items.Add(MoveToScript())
    lstScript.SelectedIndex = lstScript.Items.Count - 1
    IsDirty = True
  End Sub

  Private Sub cmdPosLoschen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPosLoschen.Click
    ' --- Lschen der markierten Zeile im ScriptFile ---
    If lstScript.Items.Count < 1 Then Return
    Dim i As Integer = lstScript.SelectedIndex
    lstScript.Items.RemoveAt(i)
    If lstScript.Items.Count > 1 Then
      lstScript.SelectedIndex = i - 1
    ElseIf lstScript.Items.Count = 1 Then
      lstScript.SelectedIndex = 1
    End If
    IsDirty = True
  End Sub

  ' --- pnlRun Routinen ---------------------------------------------------

  Private Sub cmdRunStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRunStart.Click
    ' --- Ausfhren eines ScriptFiles -----------------
    If lstScript.Items.Count < 1 Then Return
    ModusWechsel(PrgModus.Run)
    Do
      lstScript.SelectedIndex = -1
      ft.NotHalt = False
      Do
        lstScript.SelectedIndex += 1
        ScriptToMove()
        ft.MoveTo(MoveWerte(0), MoveWerte(1), MoveWerte(2))
        Zusatz(MoveWerte(3))
      Loop While (lstScript.SelectedIndex < lstScript.Items.Count - 1) And Not ft.NotHalt
    Loop While chkRunRepeat.Checked
    ModusWechsel(PrgModus.TeachIn)
  End Sub

  Private Sub cmdRunClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRunTo.Click, cmdRunForward.Click, cmdRunBack.Click
    ' --- Ausfhren einer Scriptzeile ---
    If lstScript.Items.Count < 1 Then Return
    Dim C As Button = sender
    Select Case C.Tag
      Case 1          ' --- Position vor der markierten
        If lstScript.SelectedIndex > 0 Then lstScript.SelectedIndex -= 1
      Case 2          ' --- Position nach der markierten
        If lstScript.SelectedIndex < lstScript.Items.Count - 1 Then lstScript.SelectedIndex += 1
      Case 3          ' --- Markierte Position
    End Select
    ModusWechsel(PrgModus.Run)
    ScriptToMove()
    ft.NotHalt = False
    ft.MoveTo(MoveWerte(0), MoveWerte(1), MoveWerte(2))
    Zusatz(MoveWerte(3))
    ModusWechsel(PrgModus.TeachIn)
  End Sub
End Class
