﻿' -----------------------------------------------------------------------------------------
' 
' ftTeachModell.VB                                                  Ulrich Müller  17.06.06
'                                                                   PCS1700 VB 2005 Express
' ftTeach : Bearbeitung der Liste der verfügbaren Modelle
'           Basis FishFace2005.DLL
' Übernahme der Tabelle RobModelle von ftTeachMain, Anzeige von RobModelle(0)
' und Übergabe der ggf. modifizierten Liste bei OK
'
' ------------------------------------------------------------------------------------------

Public Class ftTeachModell

  Private pd As ftTeachDaten
  Private Modell As RobSatz

  Public Sub New(ByVal pd As ftTeachDaten)
    InitializeComponent()
    Me.pd = pd
    Modell = pd.RobModelle(0)
  End Sub

  Private Sub ftTeachModell_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' --- Erstellen der Liste der RobotNamen in cboName,
    '      Auslösen von cboName_SelectedIndexChanged
    Dim i%
    cboName.Items.Clear()
    For i = 0 To pd.RobModelle.Length - 1
      cboName.Items.Add(pd.RobModelle(i).Name)
    Next
    cboName.SelectedIndex = 0
  End Sub

  Private Sub cmdOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOK.Click
    ' --- Übernahme der ggf. modifizierten Werte aus den Anzeigefeldern nach RobModelle
    Modell.Name = cboName.Text
    Modell.Typ = cboTyp.SelectedIndex
    Modell.Text = txtText.Text
    Modell.SauleMax = mskSaule.Text
    Modell.ArmHMax = mskArmH.Text
    Modell.ArmVMax = mskArmV.Text
    Modell.GreiferMax = mskGreifer.Text
    pd.RobModelle(0) = Modell
    If chkUpdate.Checked Then pd.RobModelle(cboName.SelectedIndex) = Modell
    Me.Close()
  End Sub

  Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click
    ' --- Beenden ohne Update
    Me.Close()
  End Sub

  Private Sub cboName_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboName.SelectedIndexChanged
    ' --- Füllen der Anzeigefelder mit den Werten des aktuellen RobModells 
    '     nach Vorgabe von cboName
    Modell = pd.RobModelle(cboName.SelectedIndex)
    cboName.Text = Modell.Name
    cboTyp.SelectedIndex = Modell.Typ
    txtText.Text = Modell.Text
    mskSaule.Text = Modell.SauleMax
    mskArmH.Text = Modell.ArmHMax
    mskArmV.Text = Modell.ArmVMax
    mskGreifer.Text = Modell.GreiferMax
  End Sub

End Class